tests: fix test_commit() for case insensitive filesystems
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
c2116a17
JH
6# Keep the original TERM for say_color
7ORIGINAL_TERM=$TERM
8
e1970ce4
JH
9# For repeatability, reset the environment to known value.
10LANG=C
899460f3 11LC_ALL=C
d9bdd39e 12PAGER=cat
e1970ce4 13TZ=UTC
c2116a17
JH
14TERM=dumb
15export LANG LC_ALL PAGER TERM TZ
8ff99e74
EW
16EDITOR=:
17VISUAL=:
18508c39 18unset GIT_EDITOR
e1970ce4
JH
19unset AUTHOR_DATE
20unset AUTHOR_EMAIL
21unset AUTHOR_NAME
22unset COMMIT_AUTHOR_EMAIL
23unset COMMIT_AUTHOR_NAME
28a94f88 24unset EMAIL
e1970ce4
JH
25unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26unset GIT_AUTHOR_DATE
29e55cd5
JH
27GIT_AUTHOR_EMAIL=author@example.com
28GIT_AUTHOR_NAME='A U Thor'
6677c466 29unset GIT_COMMITTER_DATE
29e55cd5
JH
30GIT_COMMITTER_EMAIL=committer@example.com
31GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
32unset GIT_DIFF_OPTS
33unset GIT_DIR
892c41b9 34unset GIT_WORK_TREE
e1970ce4
JH
35unset GIT_EXTERNAL_DIFF
36unset GIT_INDEX_FILE
37unset GIT_OBJECT_DIRECTORY
0454dd93 38unset GIT_CEILING_DIRECTORIES
e1970ce4
JH
39unset SHA1_FILE_DIRECTORIES
40unset SHA1_FILE_DIRECTORY
8d0fc48f
SP
41GIT_MERGE_VERBOSITY=5
42export GIT_MERGE_VERBOSITY
29e55cd5
JH
43export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
8ff99e74 45export EDITOR VISUAL
82ebb0b6 46GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
e1970ce4 47
886a3907
JH
48# Protect ourselves from common misconfiguration to export
49# CDPATH into the environment
50unset CDPATH
51
3d5c0cc9 52case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
53 1|2|true)
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
58 ;;
59esac
60
e1970ce4
JH
61# Each test should start with something like this, after copyright notices:
62#
63# test_description='Description of this test...
64# This test checks if command xyzzy does the right thing...
65# '
66# . ./test-lib.sh
c2116a17
JH
67[ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
69 export TERM &&
70 [ -t 1 ] &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
74 ) &&
55db1df0 75 color=t
e1970ce4 76
e1970ce4
JH
77while test "$#" -ne 0
78do
79 case "$1" in
80 -d|--d|--de|--deb|--debu|--debug)
81 debug=t; shift ;;
886856ab
JH
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83 immediate=t; shift ;;
5e2c08c6
LW
84 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85 export GIT_TEST_LONG=t; shift ;;
e1970ce4 86 -h|--h|--he|--hel|--help)
570f3226 87 help=t; shift ;;
e1970ce4
JH
88 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89 verbose=t; shift ;;
1ece1274
PH
90 -q|--q|--qu|--qui|--quie|--quiet)
91 quiet=t; shift ;;
55db1df0 92 --no-color)
faa4bc35 93 color=; shift ;;
abb7c7b3 94 --no-python)
7cdbff14
JH
95 # noop now...
96 shift ;;
e1970ce4
JH
97 *)
98 break ;;
99 esac
100done
101
55db1df0
PH
102if test -n "$color"; then
103 say_color () {
c2116a17
JH
104 (
105 TERM=$ORIGINAL_TERM
106 export TERM
55db1df0
PH
107 case "$1" in
108 error) tput bold; tput setaf 1;; # bold red
109 skip) tput bold; tput setaf 2;; # bold green
110 pass) tput setaf 2;; # green
111 info) tput setaf 3;; # brown
1ece1274 112 *) test -n "$quiet" && return;;
55db1df0
PH
113 esac
114 shift
72d404de 115 printf "* %s" "$*"
55db1df0 116 tput sgr0
b8eecafd 117 echo
c2116a17 118 )
55db1df0
PH
119 }
120else
121 say_color() {
1ece1274 122 test -z "$1" && test -n "$quiet" && return
55db1df0
PH
123 shift
124 echo "* $*"
125 }
126fi
127
128error () {
129 say_color error "error: $*"
35641310 130 trap - EXIT
55db1df0
PH
131 exit 1
132}
133
134say () {
135 say_color info "$*"
136}
137
570f3226
MB
138test "${test_description}" != "" ||
139error "Test script did not set test_description."
140
141if test "$help" = "t"
142then
143 echo "$test_description"
144 exit 0
145fi
146
4d9d62fa 147exec 5>&1
e1970ce4
JH
148if test "$verbose" = "t"
149then
150 exec 4>&2 3>&1
151else
152 exec 4>/dev/null 3>/dev/null
153fi
154
155test_failure=0
156test_count=0
41ac414e
JH
157test_fixed=0
158test_broken=0
2d84e9fb 159test_success=0
e1970ce4 160
faa4bc35
CB
161die () {
162 echo >&5 "FATAL: Unexpected exit with code $?"
163 exit 1
164}
165
35641310 166trap 'die' EXIT
41184273 167
02b35660
BD
168# The semantics of the editor variables are that of invoking
169# sh -c "$EDITOR \"$@\"" files ...
170#
171# If our trash directory contains shell metacharacters, they will be
172# interpreted if we just set $EDITOR directly, so do a little dance with
173# environment variables to work around this.
174#
175# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 176# that we're using.
02b35660
BD
177test_set_editor () {
178 FAKE_EDITOR="$1"
179 export FAKE_EDITOR
180 VISUAL='"$FAKE_EDITOR"'
181 export VISUAL
182}
183
04509738
JH
184test_tick () {
185 if test -z "${test_tick+set}"
186 then
21afc41c 187 test_tick=1112911993
04509738
JH
188 else
189 test_tick=$(($test_tick + 60))
190 fi
21afc41c
JH
191 GIT_COMMITTER_DATE="$test_tick -0700"
192 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
193 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
194}
e1970ce4 195
00884968
JS
196# Call test_commit with the arguments "<message> [<file> [<contents>]]"
197#
198# This will commit a file with the given contents and the given commit
199# message. It will also add a tag with <message> as name.
200#
201# Both <file> and <contents> default to <message>.
202
203test_commit () {
e656fc97 204 file=${2:-"$1.t"}
00884968
JS
205 echo "${3-$1}" > "$file" &&
206 git add "$file" &&
207 test_tick &&
208 git commit -m "$1" &&
209 git tag "$1"
210}
211
212# Call test_merge with the arguments "<message> <commit>", where <commit>
213# can be a tag pointing to the commit-to-merge.
214
215test_merge () {
216 test_tick &&
217 git merge -m "$1" "$2" &&
218 git tag "$1"
219}
220
886856ab
JH
221# You are not expected to call test_ok_ and test_failure_ directly, use
222# the text_expect_* functions instead.
223
224test_ok_ () {
e1970ce4 225 test_count=$(expr "$test_count" + 1)
2d84e9fb 226 test_success=$(expr "$test_success" + 1)
55db1df0 227 say_color "" " ok $test_count: $@"
e1970ce4
JH
228}
229
886856ab 230test_failure_ () {
e1970ce4
JH
231 test_count=$(expr "$test_count" + 1)
232 test_failure=$(expr "$test_failure" + 1);
55db1df0 233 say_color error "FAIL $test_count: $1"
bf0dd8a8
JH
234 shift
235 echo "$@" | sed -e 's/^/ /'
35641310 236 test "$immediate" = "" || { trap - EXIT; exit 1; }
886856ab
JH
237}
238
41ac414e
JH
239test_known_broken_ok_ () {
240 test_count=$(expr "$test_count" + 1)
241 test_fixed=$(($test_fixed+1))
242 say_color "" " FIXED $test_count: $@"
243}
244
245test_known_broken_failure_ () {
246 test_count=$(expr "$test_count" + 1)
247 test_broken=$(($test_broken+1))
248 say_color skip " still broken $test_count: $@"
249}
886856ab
JH
250
251test_debug () {
8e832ebc 252 test "$debug" = "" || eval "$1"
e1970ce4
JH
253}
254
4d9d62fa 255test_run_ () {
4d9d62fa
PR
256 eval >&3 2>&4 "$1"
257 eval_ret="$?"
4d9d62fa
PR
258 return 0
259}
260
04ece593
JH
261test_skip () {
262 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
263 this_test="$this_test.$(expr "$test_count" + 1)"
264 to_skip=
265 for skp in $GIT_SKIP_TESTS
266 do
267 case "$this_test" in
268 $skp)
269 to_skip=t
270 esac
271 done
272 case "$to_skip" in
273 t)
55db1df0 274 say_color skip >&3 "skipping test: $@"
04ece593 275 test_count=$(expr "$test_count" + 1)
55db1df0 276 say_color skip "skip $test_count: $1"
04ece593
JH
277 : true
278 ;;
279 *)
280 false
281 ;;
282 esac
283}
284
e1970ce4 285test_expect_failure () {
8e832ebc 286 test "$#" = 2 ||
e1970ce4 287 error "bug in the test script: not 2 parameters to test-expect-failure"
04ece593 288 if ! test_skip "$@"
e1970ce4 289 then
41ac414e 290 say >&3 "checking known breakage: $2"
04ece593 291 test_run_ "$2"
41ac414e 292 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 293 then
41ac414e 294 test_known_broken_ok_ "$1"
04ece593 295 else
41ac414e 296 test_known_broken_failure_ "$1"
04ece593 297 fi
e1970ce4 298 fi
7a0cf2d0 299 echo >&3 ""
e1970ce4
JH
300}
301
302test_expect_success () {
8e832ebc 303 test "$#" = 2 ||
e1970ce4 304 error "bug in the test script: not 2 parameters to test-expect-success"
04ece593 305 if ! test_skip "$@"
e1970ce4 306 then
04ece593
JH
307 say >&3 "expecting success: $2"
308 test_run_ "$2"
309 if [ "$?" = 0 -a "$eval_ret" = 0 ]
310 then
311 test_ok_ "$1"
312 else
313 test_failure_ "$@"
314 fi
e1970ce4 315 fi
7a0cf2d0 316 echo >&3 ""
e1970ce4
JH
317}
318
d3bfdb75
FK
319test_expect_code () {
320 test "$#" = 3 ||
321 error "bug in the test script: not 3 parameters to test-expect-code"
04ece593 322 if ! test_skip "$@"
d3bfdb75 323 then
04ece593
JH
324 say >&3 "expecting exit code $1: $3"
325 test_run_ "$3"
326 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
327 then
328 test_ok_ "$2"
329 else
330 test_failure_ "$@"
331 fi
d3bfdb75 332 fi
7a0cf2d0 333 echo >&3 ""
d3bfdb75
FK
334}
335
fb32c410
LW
336# test_external runs external test scripts that provide continuous
337# test output about their progress, and succeeds/fails on
338# zero/non-zero exit code. It outputs the test output on stdout even
339# in non-verbose mode, and announces the external script with "* run
340# <n>: ..." before running it. When providing relative paths, keep in
341# mind that all scripts run in "trash directory".
342# Usage: test_external description command arguments...
343# Example: test_external 'Perl API' perl ../path/to/test.pl
344test_external () {
345 test "$#" -eq 3 ||
346 error >&5 "bug in the test script: not 3 parameters to test_external"
347 descr="$1"
348 shift
349 if ! test_skip "$descr" "$@"
350 then
351 # Announce the script to reduce confusion about the
352 # test output that follows.
353 say_color "" " run $(expr "$test_count" + 1): $descr ($*)"
354 # Run command; redirect its stderr to &4 as in
355 # test_run_, but keep its stdout on our stdout even in
356 # non-verbose mode.
357 "$@" 2>&4
358 if [ "$?" = 0 ]
359 then
360 test_ok_ "$descr"
361 else
362 test_failure_ "$descr" "$@"
363 fi
364 fi
365}
366
367# Like test_external, but in addition tests that the command generated
368# no output on stderr.
369test_external_without_stderr () {
370 # The temporary file has no (and must have no) security
371 # implications.
372 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
373 stderr="$tmp/git-external-stderr.$$.tmp"
374 test_external "$@" 4> "$stderr"
375 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
376 descr="no stderr: $1"
377 shift
378 say >&3 "expecting no stderr from previous command"
379 if [ ! -s "$stderr" ]; then
380 rm "$stderr"
381 test_ok_ "$descr"
382 else
383 if [ "$verbose" = t ]; then
384 output=`echo; echo Stderr is:; cat "$stderr"`
385 else
386 output=
387 fi
388 # rm first in case test_failure exits.
389 rm "$stderr"
390 test_failure_ "$descr" "$@" "$output"
391 fi
392}
393
74359821
JH
394# This is not among top-level (test_expect_success | test_expect_failure)
395# but is a prefix that can be used in the test script, like:
396#
397# test_expect_success 'complain and die' '
398# do something &&
399# do something else &&
400# test_must_fail git checkout ../outerspace
401# '
402#
403# Writing this as "! git checkout ../outerspace" is wrong, because
404# the failure could be due to a segv. We want a controlled failure.
405
406test_must_fail () {
407 "$@"
5a269730 408 test $? -gt 0 -a $? -le 129 -o $? -gt 192
74359821
JH
409}
410
82ebb0b6
JK
411# test_cmp is a helper function to compare actual and expected output.
412# You can use it like:
413#
414# test_expect_success 'foo works' '
415# echo expected >expected &&
416# foo >actual &&
417# test_cmp expected actual
418# '
419#
420# This could be written as either "cmp" or "diff -u", but:
421# - cmp's output is not nearly as easy to read as diff -u
422# - not all diff versions understand "-u"
423
424test_cmp() {
425 $GIT_TEST_CMP "$@"
426}
427
0509eb21 428# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
429# Usage: test_create_repo <directory>
430test_create_repo () {
431 test "$#" = 1 ||
432 error "bug in the test script: not 1 parameter to test-create-repo"
433 owd=`pwd`
434 repo="$1"
bfdbee98 435 mkdir -p "$repo"
eedf8f97 436 cd "$repo" || error "Cannot setup test environment"
4c7ba956 437 "$GIT_EXEC_PATH/git" init "--template=$GIT_EXEC_PATH/templates/blt/" >&3 2>&4 ||
5c94f87e 438 error "cannot run git init -- have you built things yet?"
eedf8f97
CW
439 mv .git/hooks .git/hooks-disabled
440 cd "$owd"
441}
a6080a0a 442
e1970ce4 443test_done () {
35641310 444 trap - EXIT
2d84e9fb
SR
445 test_results_dir="$TEST_DIRECTORY/test-results"
446 mkdir -p "$test_results_dir"
447 test_results_path="$test_results_dir/${0%-*}-$$"
448
449 echo "total $test_count" >> $test_results_path
450 echo "success $test_success" >> $test_results_path
451 echo "fixed $test_fixed" >> $test_results_path
452 echo "broken $test_broken" >> $test_results_path
453 echo "failed $test_failure" >> $test_results_path
454 echo "" >> $test_results_path
41ac414e
JH
455
456 if test "$test_fixed" != 0
457 then
458 say_color pass "fixed $test_fixed known breakage(s)"
459 fi
460 if test "$test_broken" != 0
461 then
462 say_color error "still have $test_broken known breakage(s)"
11d54b8b
JH
463 msg="remaining $(($test_count-$test_broken)) test(s)"
464 else
465 msg="$test_count test(s)"
41ac414e 466 fi
e1970ce4 467 case "$test_failure" in
10b94e28 468 0)
e1970ce4 469 # We could:
9231e3a9 470 # cd .. && rm -fr 'trash directory'
e1970ce4
JH
471 # but that means we forbid any tests that use their own
472 # subdirectory from calling test_done without coming back
473 # to where they started from.
474 # The Makefile provided will clean this test area so
475 # we will leave things as they are.
476
11d54b8b 477 say_color pass "passed all $msg"
abc5d372
JS
478
479 test -d "$remove_trash" &&
480 cd "$(dirname "$remove_trash")" &&
481 rm -rf "$(basename "$remove_trash")"
482
e1970ce4
JH
483 exit 0 ;;
484
485 *)
11d54b8b 486 say_color error "failed $test_failure among $msg"
e1970ce4
JH
487 exit 1 ;;
488
489 esac
490}
491
492# Test the binaries we have just built. The tests are kept in
9adefee5 493# t/ subdirectory and are run in 'trash directory' subdirectory.
2d84e9fb
SR
494TEST_DIRECTORY=$(pwd)
495PATH=$TEST_DIRECTORY/..:$PATH
a0fa2a10 496GIT_EXEC_PATH=$(pwd)/..
8683a45d 497GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
8bfa6bd6 498unset GIT_CONFIG
8bfa6bd6
JK
499GIT_CONFIG_NOSYSTEM=1
500GIT_CONFIG_NOGLOBAL=1
501export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
49ccb087 502
6fcca938
PB
503GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
504export GITPERLLIB
eea42069
JH
505test -d ../templates/blt || {
506 error "You haven't built things yet, have you?"
507}
e1970ce4 508
56cf9806
EW
509if ! test -x ../test-chmtime; then
510 echo >&2 'You need to build test-chmtime:'
511 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
512 exit 1
513fi
514
7cf7f54a
JK
515. ../GIT-BUILD-OPTIONS
516
e1970ce4 517# Test repository
abc5d372 518test="trash directory.$(basename "$0" .sh)"
5a4a088a 519test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
8d14ac94 520rm -fr "$test" || {
35641310 521 trap - EXIT
8d14ac94
JH
522 echo >&5 "FATAL: Cannot prepare test area"
523 exit 1
524}
525
4a7aaccd 526test_create_repo "$test"
1bd9c648
LW
527# Use -P to resolve symlinks in our working directory so that the cwd
528# in subprocesses like git equals our $PWD (for pathname comparisons).
529cd -P "$test" || exit 1
04ece593
JH
530
531this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
532for skp in $GIT_SKIP_TESTS
533do
534 to_skip=
535 for skp in $GIT_SKIP_TESTS
536 do
537 case "$this_test" in
538 $skp)
539 to_skip=t
540 esac
541 done
542 case "$to_skip" in
543 t)
55db1df0
PH
544 say_color skip >&3 "skipping test $this_test altogether"
545 say_color skip "skip all tests in $this_test"
04ece593
JH
546 test_done
547 esac
548done